
// Load dts shapes and merge animations
datablock TSShapeConstructor(FireflyHoleBotDts)
{
	baseShape  = "./firefly7.dts";
	sequence0  = "./fy2_root.dsq root";

	sequence1  = "./fy2_run.dsq run";
	sequence2  = "./fy2_run.dsq walk";
	sequence3  = "./fy2_back.dsq back";
	sequence4  = "./fy2_side.dsq side";

	sequence5  = "./fy2_root.dsq crouch";
	sequence6  = "./fy2_run.dsq crouchRun";
	sequence7  = "./fy2_back.dsq crouchBack";
	sequence8  = "./fy2_side.dsq crouchSide";

	sequence9  = "./fy2_look.dsq look";
	sequence10 = "./fy2_root.dsq headside";
	sequence11 = "./fy2_root.dsq headUp";

	sequence12 = "./fy2_jumpfly.dsq jump";
	sequence13 = "./fy2_jumpfly.dsq standjump";
	sequence14 = "./fy2_flyloop.dsq fall";
	sequence15 = "./fy2_root.dsq land";

	sequence16 = "./fy2_attack.dsq armAttack";
	sequence17 = "./fy2_root.dsq armReadyLeft";
	sequence18 = "./fy2_root.dsq armReadyRight";
	sequence19 = "./fy2_root.dsq armReadyBoth";
	sequence20 = "./fy2_root.dsq spearready";  
	sequence21 = "./fy2_attack.dsq spearThrow";

	sequence22 = "./fy2_root.dsq talk";  

	sequence23 = "./fy2_death1.dsq death1"; 
	
	sequence24 = "./fy2_root.dsq shiftUp";
	sequence25 = "./fy2_root.dsq shiftDown";
	sequence26 = "./fy2_root.dsq shiftAway";
	sequence27 = "./fy2_root.dsq shiftTo";
	sequence28 = "./fy2_root.dsq shiftLeft";
	sequence29 = "./fy2_root.dsq shiftRight";
	sequence30 = "./fy2_root.dsq rotCW";
	sequence31 = "./fy2_root.dsq rotCCW";

	sequence32 = "./fy2_root.dsq undo";
	sequence33 = "./fy2_attack.dsq plant";

	sequence34 = "./fy2_root.dsq sit";

	sequence35 = "./fy2_attack.dsq wrench";

   sequence36 = "./fy2_attack.dsq activate";
   sequence37 = "./fy2_attack.dsq activate2";

   sequence38 = "./fy2_root.dsq leftrecoil";

   sequence39 = "./fy2_fly.dsq Fly";
   sequence40 = "./fy2_light_glow.dsq lightGlow";
   sequence40 = "./fy2_flash.dsq Flash";
};    

//datablock AudioProfile(HorseJumpSound)
//{
//   fileName = "./jumpHorse.wav";
//   description = AudioClose3d;
//   preload = true;
//};

datablock fxDTSBrickData (BrickFireflyBot_HoleSpawnData)
{
	brickFile = "Add-ons/Bot_Hole/6xSpawn.blb";
	category = "Special";
	subCategory = "Holes";
	uiName = "Firefly Hole";
	iconName = "Add-Ons/Bot_BugMod2/icon_firefly";

	bricktype = 2;
	cancover = 0;
	orientationfix = 1;
	indestructable = 1;

	isBotHole = 1;
	holeBot = "FireflyHoleBot";
};

 datablock PlayerData(FireflyHoleBot : PlayerStandardArmor)
{
	//category = "Vehicles";
	shapeFile = "./firefly7.dts";
//	mass = 60;
	drag = 0.5;		//0.8

	cameraMaxDist = 6;
	cameraTilt = 0.1;//0.174 * 2.5; //~25 degrees
	cameraVerticalOffset = 2;

	cameradefaultFOV = 90;
	cameraMaxFov = 120;
	cameraMinFov = 10;

	//minlookangle = -1;
	//maxlookangle = -1;
	minlookangle = -1.2;
	maxlookangle = 1.2;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
//	jetForce = 2000;

	jumpForce = 16 * 90; //20 * 90;
	jumpDelay = 0;
	jumpsound = "";

	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	maxDamage = 120;

//	runforce = 100 * 90;
	maxForwardSpeed = 10;
	maxBackwardSpeed = 8;
	maxSideSpeed = 8;
	attackpower = 18;
	
	maxForwardCrouchSpeed = 8;
	maxBackwardCrouchSpeed = 8;
	maxSideCrouchSpeed = 8;

	boundingBox			= vectorScale("2.4 2.4 0.8", 4); //"2.5 2.5 2.4";
	crouchBoundingBox	= vectorScale("2.4 2.4 0.8", 4); //"2.5 2.5 2.4";
	proneBoundingBox	= vectorScale("2.4 2.4 0.8", 4); //"2.5 2.5 2.4";

	maxStepHeight = 0.3;

//	BrickDestroyMaxVolume = 50;
//	BrickMaxJumpHeight = 5;

	uiName = "B2 Firefly";
	rideable = true;
	canRide = false;
//	BrickKillRadius = 1;
//	FollowAnim = "ArmReadyright";
//	randomwalk = 1;
//	aimatplayer = 1;
//	SpecialAttack = 0;
//	NoBloodyHands = 1;
//	DoNotZombify = 1;
//	chance = 20;
//	ZombieTeam = "MAS";
//	ignorePipeBombs = 1;
	paintable = true;
//	SearchRadius = 70;
	numMountPoints = 0;
//	isGoodGuy = 1;
	airControl = 0.6;

    minImpactSpeed = 160;
	speedDamageScale = 0.5;

	maxEnergy = 100;
	rechargeRate = 1;
	showEnergyBar = true;

	useCustomPainEffects = true;
	PainHighImage = "PainHighImage";
	PainMidImage  = "PainMidImage";
	PainLowImage  = "PainLowImage";
	PainSound           = "";
	DeathSound          = "";

	//Hole Attributes

	isHoleBot = 1;

	//Spawning option
	hSpawnTooClose = 0;//Doesn't spawn when player is too close and can see it
	  hSpawnTCRange = 8;//above range, set in brick units
	hSpawnClose = 0;//Only spawn when close to a player, can be used with above function as long as hSCRange is higher than hSpawnTCRange
	  hSpawnCRange = 32;//above range, set in brick units

	hType = Friendly; //Enemy,Friendly, Neutral
	  hNeutralAttackChance = 0; //0 to 100, Chance that this type will attack neutral bots, ie horses/vehicles/civilians
	//can have unique types, nazis will attack zombies but nazis will not attack other bots labeled nazi
	hName = "Firefly";//cannot contain spaces
	hTickRate = 3000;
	
	//Wander Options
	hWander = 1;//Enables random walking
	  hSmoothWander = 1;//This is in addition to regular wander, makes them walk a bit longer, and a bit smoother
	  hReturnToSpawn = 1;//Returns to spawn when too far
	  hSpawnDist = 48;//Defines the distance bot can travel away from spawnbrick
	  hGridWander = 0;//Locks the bot to a grid, overwrites other settings
	
	//Searching options
	hSearch = 1;//Search for Players
	  hSearchRadius = 64;//in brick units
	  hSight = 1;//Require bot to see player before pursuing
	  hStrafe = 0;//Randomly strafe while following player
	hSearchFOV = 0;//if enabled disables normal hSearch
	  hFOVRange = 0.7; // determines the angle we can see the player at, 0.7 is about normal fov for players, if 0 we can see all in front, if 1 we could only see someone perfectly ahead, can be negative
	  // hFOVRadius = 6; // no longer used, we now use searchRadius
	  hHearing = 1;//If it hears a player it'll look in the direction of the sound

	  hAlertOtherBots = 0;//Alerts other bots when he sees a player, or gets attacked

	//Attack Options
	hMelee = 1;//Melee
	  hAttackDamage = 10;//Melee Damage
	hShoot = 1;
	  hWep = "FireFlyBashItem";
	  hShootTimes = 4;//Number of times the bot will shoot between each tick
	  hMaxShootRange = 32;//The range in which the bot will shoot the player	//256
	  hAvoidCloseRange = 0;//
		hTooCloseRange = 7;//in brick units

	//Misc options
	hActivateDirection = 0; // 0 1 2, determines the direction you have to face the bot to activate him, both, front back
	hMoveSlowdown = 0; // bool, determines wether the bot will slow down when following enemies
	hAvoidObstacles = 1;
	hSuperStacker = 0;//When enabled makes the bots stack a bit better, in other words, jumping on each others heads to get to a player
	hSpazJump = 1;//Makes bot jump when the user their following is higher than them
	hAFKOmeter = 1;//Determines how often the bot will wander or do other idle actions, higher it is the less often he does things

	hIdle = 1;// Enables use of idle actions, actions which are done when the bot is not doing anything else
	  hIdleAnimation = 0;//Plays random animations/emotes, sit, click, love/hate/etc
	  hIdleLookAtOthers = 1;//Randomly looks at other players/bots when not doing anything else
	    hIdleSpam = 0;//Makes them spam click and spam hammer/spraycan
	  hSpasticLook = 1;//Makes them look around their environment a bit more.
	hEmote = 0;

};
function FireflyHoleBot::onAdd(%this,%obj)
{
	armor::onAdd(%this,%obj);

	%color = getRandom(0,2);
	if(%color == 0)
		%obj.chestColor = "1 0.588 0.0 1";
	if(%color == 1)
		%obj.chestColor = "1 0.354 0.0 1";
	if(%color == 2)
		%obj.chestColor = "1 0.760 0.418 1";

	GameConnection::ApplyBodyParts(%obj);
	GameConnection::ApplyBodyColors(%obj);

//	schedule(15,0,recolorbug,%obj);
}
function FireFlyHoleBot::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+200)
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = true;
		%obj.addVelocity("0 0 10");
		%obj.playThread(0, "Fly"); //animation
//		ServerPlay3D(AirDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj)) 
		return;
	%obj.forbidJump = false;
}

